# -*- coding: utf-8 -*-
# Copyright 2024 - The Android Open Source Project
#
# Licensed under the Apache License, Version 2.0 (the',  help='License');
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an',  help='AS IS' BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
import logging
from abc import ABC

from aemu.filters.argument_filter import apply_argument_filter


class CompilerConverter(ABC):
    """
    Abstract base class for converting compiler invocations in Bazel.

    This class provides a framework for extracting source files from compiler
    arguments, managing language-specific extensions, and filtering actions.
    """

    def __init__(self, bazel):
        """
        Initializes a CompilerConverter instance.

        Args:
            bazel: (object): A reference to an object representing the Bazel context.
        """

        self.bazel = bazel
        self.filters = []
        self.src_ext = {
            "c": [".c", ".i"],
            "cpp": [
                ".cc",
                ".cpp",
                ".cxx",
                ".c++",
                ".C",
                ".CC",
                ".cp",
                ".CPP",
                ".C++",
                ".CXX",
                ".ii",
            ],
            "objc": [".m"],
            "objcpp": [".mm", ".M"],
            "asm": [".s", ".asm"],
            "asm_pre": [".S"],
        }
        self.all_ext = [x for xs in self.src_ext.values() for x in xs]
        self.ext_lang_map = {
            "c": "-xc",
            "cpp": "-xc++",
            "objc": "-xobjective-c",
            "objcpp": "-xobjective-c++",
            "asm": "-xassembler",
            "asm_pre": "-xassembler-with-cpp",
        }

    def source_file(self, arguments) -> str:
        """
        Extracts the source file from a list of compiler arguments.

        Args:
            arguments (list): A list of compiler arguments.

        Returns:
            str: The path to the source file.

        Raises:
            ValueError: If no source file can be found in the arguments.
        """

        source_file_candidates = [
            arg
            for arg in arguments
            if not arg.startswith("-") and any([arg.endswith(x) for x in self.all_ext])
        ]
        if not source_file_candidates:
            raise ValueError(f"No source files found in compile args: {arguments}.")
        return self.bazel.normalizer.apply(source_file_candidates[0])

    def convert(self, bazel_cc_arguments):
        """Converts Bazel compiler arguments into a compile_commands.json entry.

        This method addresses the challenges posed by Bazel's sandboxing, which
        creates compiler arguments that might be less useful for external tools
        like clangd. The goal is to normalize and adapt the arguments for better
        compatibility with such tools.

        Args:
            bazel_cc_arguments (list): A list of compiler arguments generated by Bazel.

        Returns:
            dict: A dictionary representing a compile_commands.json entry, containing:
                * directory (str): The working directory of the compilation.
                * arguments (list): The normalized list of compiler arguments.
                * file (str): The path to the source file being compiled.

        See Also:
            * compile_commands.json specification: https://clang.llvm.org/docs/JSONCompilationDatabase.html
        """
        file = self.source_file(bazel_cc_arguments)
        arguments = apply_argument_filter(bazel_cc_arguments, self.filters)
        directory = self.bazel.info["workspace"]
        logging.debug("[%s] %s", file, " ".join(arguments))

        return {"directory": directory, "arguments": arguments, "file": file}
